﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DockManager;
using System.Diagnostics;

namespace CustomizableFloatingPane
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        Point pointInToolWindow;
        public Window1()
        {
            InitializeComponent();

            xamDockManager1.ToolWindowLoaded += new EventHandler<Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs>(xamDockManager1_ToolWindowLoaded);
        }

        void xamDockManager1_ToolWindowLoaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {
            PaneToolWindow window = e.Window;
            window.PreviewMouseDoubleClick += new MouseButtonEventHandler(OnMouseDoubleClick);
            window.PreviewMouseMove+=new MouseEventHandler(OnMouseMove);
            window.PreviewMouseLeftButtonDown+=new MouseButtonEventHandler(OnMouseLeftButtonClick);

            window.HorizontalAlignmentMode = ToolWindowAlignmentMode.Manual;
            window.VerticalAlignmentMode = ToolWindowAlignmentMode.Manual;
            window.UseOSNonClientArea = false;

            window.Style = xamDockManager1.Resources["style"] as Style;
        }

        void OnMouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            PaneToolWindow window = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(PaneToolWindow), false) as PaneToolWindow;

            (window.Pane.Panes[0] as ContentPane).Activate();
            (window.Pane.Panes[0] as ContentPane).ExecuteCommand(ContentPaneCommands.ToggleDockedState);
        }

        private void OnMouseMove(object sender, MouseEventArgs e)
        {
            PaneToolWindow window = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(PaneToolWindow), false) as PaneToolWindow;
            if (Mouse.LeftButton == MouseButtonState.Pressed)
            {
                Point p = this.PointToScreen(Mouse.GetPosition(this));
                window.Left = p.X - pointInToolWindow.X;
                window.Top = p.Y - pointInToolWindow.Y;
            }
        }

        private void OnMouseLeftButtonClick(object sender, MouseButtonEventArgs e)
        {
            PaneToolWindow window = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(PaneToolWindow), false) as PaneToolWindow;

            pointInToolWindow = Mouse.GetPosition(window);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            PaneToolWindow window = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject,
                typeof(PaneToolWindow), false) as PaneToolWindow;

            (window.Pane.Panes[0] as ContentPane).Activate();
            (window.Pane.Panes[0] as ContentPane).ExecuteCommand(ContentPaneCommands.Close);
        }
    }
}
